import sqlmodel
from sqlalchemy.exc import IntegrityError
from sqlalchemy.future import Engine

from . import models


def add_account(engine: Engine, account: models.Account) -> bool:
    """Adds account to the database. Returns true on success,
    false otherwise"""
    try:
        with sqlmodel.Session(engine) as session:
            session.add(account)
            session.commit()
    except IntegrityError:
        return False
    else:
        return True


def add_master_pass(engine: Engine, master_pass: models.MasterPass) -> bool:
    """Adds master password the database. Returns true on success,
    false otherwise"""
    try:
        with sqlmodel.Session(engine) as session:
            session.add(master_pass)
            session.commit()
    except IntegrityError:
        return False
    else:
        return True
