import sqlmodel
from sqlalchemy.future import Engine

from . import models  # noqa

HOUR_IN_SECONDS = 3600


def get_engine(host: str, user: str, passwd: str, db: str) -> Engine:
    """Creates an engine for mariadb with pymysql as connector"""
    uri = f"mariadb+pymysql://{user}:{passwd}@{host}/{db}"
    engine = sqlmodel.create_engine(uri, pool_recycle=HOUR_IN_SECONDS)
    return engine


def prepare(engine: Engine) -> None:
    """Creates all tables, indexes and constrains in the database"""
    sqlmodel.SQLModel.metadata.create_all(engine)
